﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8.28
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Type tMyContact(ID As Long, DisplayName As String, PhoneNumber As String)
	Private mlstMyContacts As List
	Private mItemHeight As Int
End Sub

Sub Globals
	Private xui As XUI
	Private xclvContacts As CustomListView
	
	Private pnlContactItem As Panel
	Private ivPhoto As ImageView
	Private etDisplayName As EditText
	Private etPhone As EditText
End Sub

Sub Activity_Create(FirstTime As Boolean)
	' Strampalato espediente per sapere che altezza ha l'item
	' un volta "scalato" dal Designer.
	Activity.LoadLayout("layContactItem")
	mItemHeight = pnlContactItem.Height
	Activity.RemoveAllViews
	
	Activity.LoadLayout("layContacts")
	
	mlstMyContacts.Initialize
	Dim lstPhones As List
	lstPhones.Initialize
	For Each Contact As cuContact In Starter.gContactsUtils.FindAllContacts(False)
		Dim MyContact As tMyContact
		MyContact.Initialize
		MyContact.ID = Contact.Id
		MyContact.DisplayName = Contact.DisplayName
		' Prende solo il primo numero che trova, il contatto potrebbe averne più d'uno.
		' Devo avere un problema con un contatto nel mio smartphone,
		' per cui uso il Try.
		MyContact.PhoneNumber = "0"
		Try
			lstPhones = Starter.gContactsUtils.GetPhones(Contact.Id)
			Dim Phone As cuPhone = lstPhones.Get(0)
			MyContact.PhoneNumber = Phone.Number
		Catch
			Log(LastException)
		End Try
		
		mlstMyContacts.Add(MyContact)
	Next

	FillxclvContacts
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Private Sub FillxclvContacts
'	mmapContacts.Clear
'	For Each Contact As cuContact In Starter.gContactsUtils.FindAllContacts(True)
'		Dim ContactWithPhoto As tMyContactWithPhoto
'		ContactWithPhoto.Initialize
'		ContactWithPhoto.Contact = Contact
'		ContactWithPhoto.Photo = Starter.gContactsUtils.GetPhoto(Contact.Id)
'		mmapContacts.Put(Contact.Id, ContactWithPhoto)
'	Next

	For i = 0 To mlstMyContacts.Size - 1
		Dim MyContact As tMyContact = mlstMyContacts.Get(i)
		Dim p As B4XView = xui.CreatePanel("")
		p.SetLayoutAnimated(0, 0, 0, xclvContacts.AsView.Width, mItemHeight)
		xclvContacts.Add(p, MyContact)
	Next
End Sub

Sub xclvContacts_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	Dim ExtraSize As Int = 20
	For i = Max(0, FirstIndex - ExtraSize) To Min(LastIndex + ExtraSize, xclvContacts.Size - 1)
		Dim p As B4XView = xclvContacts.GetPanel(i)
		If p.NumberOfViews = 0 Then
			Dim MyContact As tMyContact = xclvContacts.GetValue(i)
			p.LoadLayout("layContactItem")
			etDisplayName.Text = MyContact.DisplayName
			etPhone.Text = MyContact.PhoneNumber
			Dim bmp As Bitmap = Starter.gContactsUtils.GetPhoto(MyContact.ID)
			If bmp.IsInitialized Then
				ivPhoto.Bitmap = bmp
			End If
		End If
	Next
End Sub

Sub xclvContacts_ItemClick (Index As Int, Value As Object)
	
End Sub
